//+------------------------------------------------------------------+
//|                                         ZZ channel breakdown.mq4 |
//|                                                 Gintaras Aldonis |
//|                                           gintariukstis@takas.lt |
//+------------------------------------------------------------------+
//  -     .               |
//    .                                   |
//   ( )   . |
//       .           |
//   .     ,    |
//   .    .   |
//      .    .  |
//            |
//  .      .            |
//                                                                   |
// glZZ_ch=40;    M5                                    |
//-------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern double ch_percent= 0.15;                 //kanalo praplatejimas -  
extern int amount_extremum=5;                   //minimalus ekstremumu skaicius -   
extern double glZZ_ch=40;                       //Maksimalus leidziamas kanalo auksti -    
extern string ZigZag="Indicator parameter";     //indikatoriaus parametrai -   
extern int ZZ_dp=5;
extern int ZZ_dv=5;
extern int ZZ_bs=3;
int       k=0;

double   p[5];                                  //ekstremumu kainu masyvas -   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  int i, t;
  double zz_ch;                                                      //   
  double p_max, p_min;                                               //    ()                                                                 
 //-------------------------------------------------------------------
 //         - 1 -
 //ZZ ekstremumu surinkimas -    (     )
 //-------------------------------------------------------------------
  for(i=0; i<=amount_extremum; i++)
  {
     p[i]=GetExtremumZZPrice(NULL, 0, i, ZZ_dp, ZZ_dv, ZZ_bs);    
  }
 //--------------------------------------------------------------------
 //    -1-
 //--------------------------------------------------------------------
 //         -2 -
 //            
 //--------------------------------------------------------------------
  p_max = ArrayMax(p); 
  Print("max=",p_max);
      
  p_min = ArrayMin(p); 
  Print("min=",p_min);      
      
 if((p_max - p_min )-glZZ_ch*Point>=0)                                              //   
   {
     Print("Kanalas=",(p_max - p_min)/Point, "     Sie ekstremumai netinka"); 
     Print(" =",(p_max - p_min)/Point, "       ");         
     return;
   }
   else
   {       
     t=GetExtremumZZTime(NULL, 0, amount_extremum, ZZ_dp, ZZ_dv, ZZ_bs);        //       

     SetTLine(Lime, "DNLine", t, p_min, Time[0], p_min, False, 0, 3);            //           
     SetTLine(Lime, "UPLine", t, p_max, Time[0], p_max, False, 0, 3);           //   
           
   } //else
                  //                     
                  VisualDoubleToText("Ch", "1.Channel", 30, (p_max - p_min)/Point, 0 );         
                  VisualDoubleToText("Up", "2.Up", 45, p_max, 4 );         
                  VisualDoubleToText("Down", "3.Down", 60, p_min, 4 );         
                  //VisualTimeToText("firstExtr", "4.firstExtr", 75, iTime(NULL, 0, t), TIME_DATE|TIME_MINUTES );
         
  zz_ch=p_max-p_min;  
         
         //   
         VisualDoubleToText("newCh", "5.newChannel", 90, zz_ch/Point, 0 );      
            
  k=amount_extremum; //   
            
  while(zz_ch < zz_ch*(1+ch_percent))                                            //   
    {
            //   
            VisualDoubleToText("whileUp", "6.whileUP", 105, p_max, 4 );         
            VisualDoubleToText("whileDown", "7.whileDown", 120, p_min, 4 ); 
            
        zz_ch=p_max-p_min;
            
            //   
            VisualDoubleToText("whileCh", "8.whileChannel", 135, zz_ch/Point, 0 );
         
        k++;
            
            //    
            VisualDoubleToText("NrExtr", "9.Nr.Extr", 150, k, 4 );
               
        double price=GetExtremumZZPrice(NULL, 0, k, ZZ_dp, ZZ_dv, ZZ_bs);        //  
               
               //   
               VisualDoubleToText("newExtr", "10.newExtr", 165, price, 4 );
               
        if(price>p_max)                                                          //      
         {
           p_max = price;                                                        //    
               
               //   
               VisualDoubleToText("newnew_max", "11.newnew_max", 180, p_max, 4 );               
         }
            
         if(price<p_min)                                                         //      
         {
            p_min = price;                                                       //    
               
               //   
               VisualDoubleToText("newnew_min", "12.newnew_min", 195, p_min, 4 );
         }
             
         zz_ch=p_max-p_min;                                                      //              
            
         if(zz_ch -glZZ_ch*Point>=0)                                             //        
            {
               Print("Kanalas=",(p_max - p_min)/Point, "     Sie ekstremumai netinka");
               Print(" =",(p_max - p_min)/Point, "       ");          
               break;                                                            //  
            }
          else                                                                   //       
            {       
               t=GetExtremumZZTime(NULL, 0, k, ZZ_dp, ZZ_dv, ZZ_bs);             //     
               
               SetTLine(Red, "DNLine", t, p_min, Time[0], p_min, False, 0, 3);  //             
               SetTLine(Blue, "UPLine", t, p_max, Time[0], p_max, False, 0, 3); //   
               
               //   
               //VisualTimeToText("Time_ahead", "13.Time ahead", 210, Time[0],0);
               VisualDoubleToText("UPLine", "14.UPLine", 225, p_max, 4 );
               VisualDoubleToText("DNLine", "15.DNLine", 240, p_min, 4 );
            }          
         }   
return(0);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                  |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//-----------------------------------------------------------------------------
//          GetExtremumZZPrice  
//+----------------------------------------------------------------------------+
//|  ??????   : 07.10.2006                                                     |
//|  ???????? : ?????????? ????????? ??????? ?? ??? ??????.                    |
//+----------------------------------------------------------------------------+
//|  ?????????:       parametrai                                               |
//|    sy - ???????????? ???????????   (NULL ??? "" - ??????? ??????)          |
//|    tf - ?????????                  (      0     - ??????? ??)              |
//|    ne - ????? ??????????  ekstremumo Nr.         (      0     - ?????????) |
//|    dp - ExtDepth                                                           |
//|    dv - ExtDeviation                                                       |
//|    bs - ExtBackstep                                                        |
//+----------------------------------------------------------------------------+
double GetExtremumZZPrice(string sy="", int tf=0, int ne=0, int dp=12, int dv=5, int bs=3) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int    i, k=iBars(sy, tf), ke=0;

  for (i=1; i<k; i++) {
    zz=iCustom(sy, tf, "ZigZag", dp, dv, bs, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(zz);
    }
  }
  Print("GetExtremumZZPrice(): Ekstremumas ZZ Nr. ",ne," nerastas ");  
  return(0);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :        .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    tf -                   (      0     -  )              |
//|    ne -             (      0     - )               |
//|    dp - ExtDepth                                                           |
//|    dv - ExtDeviation                                                       |
//|    bs - ExtBackstep                                                        |
//+----------------------------------------------------------------------------+
int GetExtremumZZTime(string sy="", int tf=0, int ne=0, int dp=12, int dv=5, int bc=3) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int    i, k=iBars(sy, tf), ke=0;

  for (i=0; i<k; i++) {
    zz=iCustom(sy, tf, "ZigZag", dp, dv, bc, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(iTime(sy, tf, i));
    }
  }
  Print("GetExtremumZZBar():    ",ne,"  ");
  return(-1);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 17.05.2008                                                     |
//|   :     .            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    x -                                          |
//+----------------------------------------------------------------------------+
double ArrayMax(double& x[]) {
  if (ArraySize(x)>0) return(x[ArrayMaximum(x)]);
  else {
    Print("ArrayMax():  !");
    return(0);
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 17.05.2008                                                     |
//|   :     .             |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    x -                                          |
//+----------------------------------------------------------------------------+
double ArrayMin(double& x[]) {
  if (ArraySize(x)>0) return(x[ArrayMinimum(x)]);
  else {
    Print("ArrayMin():  !");
    return(0);
  }
}
//---------------------------------------------------------------------
//  Vizualizacija
//     
//-------------------------------------------------------------------- 
 int VisualDoubleToText(string name, string text, int y,double param, int digit )
 {  
            ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
            ObjectSetText(name, text,12, "Verdana", White );
            ObjectSet(name, OBJPROP_XDISTANCE, 20);
            ObjectSet(name, OBJPROP_YDISTANCE, y);
            ObjectSet(name, OBJPROP_CORNER, 0); 
            ObjectCreate(name+"skaicius", OBJ_LABEL, 0, 0, 0);
            ObjectSetText(name+"skaicius", DoubleToStr(param,digit),12, "Verdana", White );
            ObjectSet(name+"skaicius", OBJPROP_XDISTANCE, 200);
            ObjectSet(name+"skaicius", OBJPROP_YDISTANCE, y);
            ObjectSet(name+"skaicius", OBJPROP_CORNER, 0); 
 }
 
 
  int VisualTimeToText(string name, string text, int y,datetime param, int mode )
 {  
            ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
            ObjectSetText(name, text,12, "Verdana", White );
            ObjectSet(name, OBJPROP_XDISTANCE, 20);
            ObjectSet(name, OBJPROP_YDISTANCE, y);
            ObjectSet(name, OBJPROP_CORNER, 0); 
            ObjectCreate(name+"skaicius", OBJ_LABEL, 0, 0, 0);
            ObjectSetText(name+"skaicius", TimeToStr(param,mode),12, "Verdana", White );
            ObjectSet(name+"skaicius", OBJPROP_XDISTANCE, 200);
            ObjectSet(name+"skaicius", OBJPROP_YDISTANCE, y);
            ObjectSet(name+"skaicius", OBJPROP_CORNER, 0); 
 }